// -*- c++ -*-

//
//      ControlPanel.java
//
//	Programmed by Jun Iio @ Real World Computing Partnership
//		      iiojun@trc.rwcp.or.jp
//
//     Modified by Y.Motomura(motomura@etl.go.jp)

import java.util.*;
import java.awt.*;

class ControlPanel extends Panel {

    Bayonnet 	BN;
    Checkbox 		move, link, unlink;
    Button 		newnode, clear, reload, option, save, option2;
    CheckboxGroup 	cbGroup;

    ControlPanel(Bayonnet manager) {
        BN = manager;
	
//        setLayout(new BorderLayout());

	Panel p1, p2;
        p1 = new Panel();
        p2 = new Panel();
//	add("North",p1);
//	add("Center",p2);
	add(p1);
	add(p2);
	p1.setLayout(new FlowLayout(FlowLayout.LEFT));
	p2.setLayout(new FlowLayout(FlowLayout.LEFT));

	Label label1 = new Label("Edit mode:");
        cbGroup = new CheckboxGroup();
        move    = new Checkbox("MOVE", cbGroup, true);
        link    = new Checkbox("LINK", cbGroup, false);
        unlink  = new Checkbox("CUT ", cbGroup, false);
	p1.add(label1);
	p1.add(move);
	p1.add(link);
	p1.add(unlink);

	Label label2 = new Label("Command:");
        newnode = new Button("New Node");
        clear = new Button("(Clear)");
        reload = new Button("Load");
        save =  new Button("(Save)");
        option = new Button("Quit");
        option2 = new Button("Reflesh");

        p2.add(label2);
        p2.add(newnode);
        p2.add(clear);
	p2.add(reload);
        p2.add(save);
	p2.add(option2);
	p2.add(option);
    }

    public boolean action(Event evt, Object arg) {
        if (arg instanceof Boolean) {
            buttonReset(BN.mode);
            if (evt.target.equals(move)) {
                BN.mode = BN.MOVE;
            } else if (evt.target.equals(link)) {
                BN.mode = BN.LINK;
            } else if (evt.target.equals(unlink)) {
                BN.mode = BN.UNLINK;
            }
/* change the current status display */
            changeCurrent(BN.mode);

            repaint();
            return true;
        }
        if ("New Node".equals(arg)) {
            BN.fd.makeNewNode();
            return true;
        }
        if ("Clear".equals(arg)) {
            BN.fd.clear();
            return true;
        }
        if ("Load".equals(arg)) {
//            BN.load();
	    System.out.println("Load");
            return true;
        }
        if ("Quit".equals(arg)) {
            BN.quit();		
        }

        if ("Reflesh".equals(arg)) {
	    BN.dp.displayAll();
	    BN.fd.repaint();
        }

        if ("Save".equals(arg)) {
            BN.fd.save();
            return true;
        }

        return false;
    }

    void buttonReset(int mode) {
        Checkbox cb;
        switch (mode) {
        case BN.MOVE:
            cb = move;
            break;
        case BN.LINK:
            cb = link;
            break;
        case BN.UNLINK:
            cb = unlink;
            break;
        default:            
            cb = move;
            break;
        }
    }

    void changeCurrent(int mode) {
        Checkbox cb;
        switch (mode) {
        case BN.MOVE:
            cb = move;
            break;
        case BN.LINK:
            cb = link;
            break;
        case BN.UNLINK:
            cb = unlink;
            break;
        default:
            cb = move;
            break;
        }
        cbGroup.setCurrent(cb);
        cb.setState(true);
    }
}
