// -*- c++ -*-

//
//      Edges.java
//
//	Programmed by Jun Iio @ Real World Computing Partnership
//		      iiojun@trc.rwcp.or.jp
//
//      Modified by Y.Motomura(motomura@etl.go.jp)

import java.util.*;
import java.awt.*;

class Edges extends Vector {

    Edges() {}

/* "pickUpById"
   [args] int id : the key ID.
   [return] Edge : the Edge object which has the key ID.
                   if such edge is not found, this returns null;
 */
    Edge pickUpById(int id) {
	for (Enumeration e = elements(); e.hasMoreElements();) {
            Edge edge = (Edge)e.nextElement();
	    if (edge.edgeId == id) return edge;
        }
        return null;
    }

/* "findEdgeLast"
   [args] int x, y : coordinates (x, y)
   [return] Edge   : the Edge object which has the biggest index 
                     in the set of edges which contains the specified point.
                     if such edge is not found, this returns null;
 */
    Edge findEdgeLast(int x, int y) {
        Edge edge;
        int idx;
        for(idx = elementCount-1; idx >= 0; idx--) {
            edge = (Edge)elementAt(idx);
            if (edge.inside(x, y)) return edge;
        }
        return null;
    }

    void paint(Graphics g) {
        for (Enumeration e = elements(); e.hasMoreElements();) {
            Edge edge = (Edge)e.nextElement();
            edge.paint(g);
        }
    }
}
