// -*- c++ -*-

//
//      Nodes.java
//
//	Programmed by Jun Iio @ Real World Computing Partnership
//		      iiojun@trc.rwcp.or.jp
//
//      Modified by Y.Motomura(motomura@etl.go.jp)

import java.util.*;
import java.awt.*;

class Nodes extends Vector {
    Nodes() {}

/* "pickUpById"
   [args] int id : the key ID.
   [return] Node : the Node object which has the key ID.
                   if such node is not found, this returns null;
 */
    Node pickUpById(int id) {
	for (Enumeration e = elements(); e.hasMoreElements();) {
            Node node = (Node)e.nextElement();
	    if (node.nodeId == id) return node;
        }
        return null;
    }

    Node pickUpByName(String key) {
	for (Enumeration e = elements(); e.hasMoreElements();) {
            Node node = (Node)e.nextElement();
	    if (node.name.equals(key)) return node;
        }
        return null;
    }

/* "findNodeLast"
   [args] int x, y : coordinates (x, y)
   [return] Node   : the Node object which has the biggest index 
                     in the set of nodes which contains the specified point.
                     if such node is not found, this returns null;
 */
    Node findNodeLast(int x, int y) {
        Node node;
        int idx;
        for(idx = elementCount-1; idx >= 0; idx--) {
            node = (Node)elementAt(idx);
            if (node.inside(x, y)) return node;
        }
        return null;
    }
    
    void paint(Graphics g) {
        for (Enumeration e = elements(); e.hasMoreElements();) {
            Node node = (Node)e.nextElement();
            node.paint(g);
        }
    }

    public void setCondProb(Bayonnet BN) {
        for (Enumeration e = elements(); e.hasMoreElements();) {
       	    Node node = (Node)e.nextElement();
	    if(node.child_f == true){
	    	node.setCondProb();
	    	node.loadCondProb();
	    }
	}
    }

    public void saveCondProb(Bayonnet BN) {
        for (Enumeration e = elements(); e.hasMoreElements();) {
       	    Node node = (Node)e.nextElement();
	    if(node.child_f == true){
	    	node.saveCondProb();
	    }
	}
    }
}




