(defvar *Bayonnet* nil)

(defun connect-BN-node (hname &optional (num 0))
   (make-client-socket-stream 
	(make-socket-address :domain af_inet :host hname :port (+ num 6700)))
)

(defun connect-Bayonnet (&optional (hname "loadlhost"))
  (setq *Bayonnet* (make-client-socket-stream 
	(make-socket-address :domain af_inet :host hname :port 6700)))
)

(defmacro bnsend  (mess &optional (st *Bayonnet*))
   (format st "~a~%" mess))

(defmacro create-node (node-name &optional (dist 1) (tblname nil))
   (eval (set node-name
	 (instance BN-Node :create
		 (send node-name :pname) dist) ))
   (if (stringp tblname)
	(eval `(send ,node-name :settable ,tblname))
	(eval `(send ,node-name :settable (,node-name . name)))
	)
)

(defclass BN-Node :slots (stm name dist state table-name))

(defmethod BN-Node
 (:init (nm dst &optional (st *Bayonnet*))
   (setq name nm dist dst stm st)
 )
 (:create (nm dst &optional (st *Bayonnet*))
   (send self :init nm dst st)
   (send self :new-node)
  )
 (:new-node ()
   (format stm "new-node ~a ~a~%" name  dist)
   (list name dist)
 )
 (:set (&rest val)
  (if (> dist  0)
   (when  (= (length val) dist)
	(format stm "~a set ~a~%" name val)
	(setq state val)
	)
   (progn
	(format stm "~a set ~a~%" name (car val))
	(setq state val)
   )
  )
 )
 (:get (&optional (cmd ""))
     (let (mess node val)
	(format stm "~a get ~a~%" name cmd)
	(loop 
	  (setq mess (read stm))
	  (setq node (car mess) val (cadr mess))
	  (if (equal (send node :pname) name)
	     (progn
	      (setq state val)
	      (return-from :get val)
	     )
	     (eval `(send ,node :set-state ,@val))
	 )
 	)
    )
 )
 (:set-state (&rest val)	(setq state val)
 )
 (:connect (n)	
	(format stm "new-edge ~a ~a~%" name (BN-Node-name n))
        (list name (BN-Node-name n))
 )
 (:setTable (tblname)
	(setq table-name tblname)
	(format stm "~a SetTable ~a~%" name tblname)
        t
 )
 (:setCondProb ()
	(format stm "~a CondProb set~%" name)
	t
 )
 (:loadCondProb ()
	(format stm "~a CondProb Load~%" name)
	t
 )
 (:saveCondProb ()
	(format stm "~a CondProb Save~%" name)
	t
 )
 (:loadpatterns (&optional (m 100))
	(format stm "~a CondProb LoadPattern ~a~%" name m)
	t
 )
 (:getpatterns (DSname delay)
	(format stm "~a CondProb GetPatterns ~a ~a~%" name DSname delay)
	t
 )
 (:learnCondProb (&optional (m 300))
	(format stm "~a CondProb Learn ~a~%" name m)
	t
 )
)
