; Connect to Bayonnet
;
(connect-bayonnet "rwcpc8")

(defvar latitudemax  45.4167)
(defvar latitudemin  26.2)

(defvar longitudemax  145.583)
(defvar longitudemin  127.683)

(defvar altitudemax  999.1)
(defvar altitudemin  0.5)

(defvar temperaturemax  28.4)
;(defvar temperaturemin  -19.6)
(defvar temperaturemin  -8.4)

;
;
(defvar tokyo '(0.493494 0.675065 0.00600841))
(defvar yokohama '( 0.480485 0.668547  0.0386541))
(defvar mito '(0.529921  0.714171 0.0288404))
(defvar kyoto '(0.458802  0.449739 0.0409573))
(defvar fukuoka '(0.384214 0.150857 0.0020028))
(defvar sendai '(0.627926  0.73838  0.0384538 ))
(defvar asahikawa '(0.914135  0.820317  0.111556))
(defvar sapporo '(0.876841  0.762588  0.0167234 ))
(defvar fukushima '(0.60104  0.715102 0.0669938))
(defvar karuizawa '(0.527319  0.607095  1))
(defvar nagoya '(0.466608  0.518641  0.0506709))
(defvar hiroshima '(0.426712  0.267244  0.00310435))
(defvar kobe '(0.441456  0.419013  0.0570799))
(defvar naha '(0.113616  0.101508  0.00230322))
(defvar kagoshima '(0.278404 0.160168  0.00340477))

; Create Nodes
;
(create-node tokyo -1)
(create-node hamamatsu -1)
(create-node matsumoto -1)

;  Create Links
;
(send hamamatsu :connect tokyo)
(send matsumoto :connect tokyo)

; Create Neural Networks
;
(send tokyo :setcondprob)


; Functions
;
(defun setvals (x y h m)
   (send latitude :set x)
   (send longitude :set y)
   (send altitude :set h)
   (send month :set m)
)

(defun setvals2 (x y h m)
   (send latitude :set (normalize x latitudemax latitudemin))
   (send longitude :set (normalize y longitudemax longitudemin))
   (send altitude :set (normalize h altitudemax altitudemin))
   (send month :set (normalize m 13.0 1.0))
)

(defun set-town (n m)
   (send latitude :set (car n))
   (send longitude :set (cadr n))
   (send altitude :set (caddr n))
   (send month :set (normalize m 13.0 1.0))
)

(defun get-temperature (n m)
   (set-town n m)
   (reconst-temperature (car (send temperature :get "forward")))
)

(defun show-temperatures (n)
  (format t "--- ~a ---~%" n)
  (dotimes (i 12)
     (format t "~a --- ~a degrees~%" (1+ i) (get-temperature n (1+ i))))
)

(defun normalize (x maxx minx)
  (setq dat (/ (- x minx) (- maxx minx)))
  (cond ((< dat 0.00002) 0)
	((> dat 1) 1)
	(t dat))
)

(defun reconst (x maxx minx)
  (+ (* x (- maxx minx)) minx)
)

(defun reconst-temperature (x)
  (reconst x temperaturemax temperaturemin)
)
